#include "..\C-Engine\CHeader.hpp"

class Control: public Script
{
    public:
    void Start();
    void Update();
};

void Control::Start()
{
SetXY(58 , 30);
}

void Control::Update()
{
    SetXY( GetX() - (IsKeyDown(KEY_CTRL_LEFT) && GetX() > 0) + (IsKeyDown(KEY_CTRL_RIGHT) && GetX() < 115) , GetY() + (IsKeyDown(KEY_CTRL_UP) && GetY() < 51) - (IsKeyDown(KEY_CTRL_DOWN) && GetY() > 0));

}

class Point: public Script
{
    public:
    void Start();
    void Update();
    void UpdateEverySecond();

    private:
    int nb_point;
    int timeur;
};

void Point::Start()
{
    SetXY( rand_int(123), rand_int(59));
    nb_point = 0;
    timeur = 30;
}

void Point::Update()
{
    if(GetObject()->CollisionTag("Fee"))
    {
        nb_point ++;
        SetXY( rand_int(123), rand_int(59));
    }

    PrintV(60 , 2 , nb_point);
    PrintV(118 , 2 , timeur);
}

void Point::UpdateEverySecond()
{
    timeur --;
    if(timeur <= 0)
    {
        GetObject()->Conteneur->RestartGame();

        PrintMini(10 , 20,"Score :" , 1);
        PrintV( 45 , 20 , nb_point);
        PrintMini(70 , 20 , "Points",1);
        PrintMini(30 , 30, "Shift pour Quitter",1);

        ML_display_vram();

        do
        {
	if(IsKeyDown(KEY_CTRL_EXIT)) GetObject()->Conteneur->StopGame();
        }while(IsKeyDown(KEY_CTRL_SHIFT) != 1 && IsKeyDown(KEY_CTRL_EXIT) != 1 );
    }
}

int main()
{


    const unsigned char Fairies1[]={0xf0, 0xf, 0x8c, 0x31, 0x83, 0xc1, 0x46, 0x62, 0x3c, 0x3c, 0x4, 0x20, 0x6, 0x60, 0xb, 0xd0, 0xa, 0x50, 0xa, 0x50, 0x6, 0x60, };
    const unsigned char Fairies2[]={0xc0, 0x3f, 0xa0, 0x5f, 0x90, 0x9f, 0x90, 0x9f, 0x89, 0x1f, 0x4f, 0x2f, 0x39, 0xcf, 0x10, 0x8f, 0x30, 0xcf, 0x59, 0xaf, 0x9f, 0x9f, 0xf0, 0xff, };

    const unsigned char Coins1[]={0x6f, 0x9f, 0x9f, 0x6f, };
    const unsigned char Coins2[]={0x6f, 0x6f, 0x6f, 0x6f, };

//****************Cration des Animations*************

    Sprite SFairies1(Fairies1,16 , 11 , -2 , 2);
    Sprite SFairies2(Fairies2,12 , 12 );

    Sprite SFairies[]={SFairies1 , SFairies2};

    Animation AFairies(SFairies , 2 ,200);

    Sprite SCoins1(Coins1 , 4 ,4);
    Sprite SCoins2(Coins2 , 4 ,4);

    Sprite SCoins[]={SCoins1 , SCoins2};

    Animation ACoins( SCoins , 2 , 250);

//*****************Creation du joueur******************

    Object Fairies;
    Fairies.ORender->SetRender( AFairies );
    Fairies.AffectTag("Fee");

    Control ScriptFairies;
    Fairies.AffectScript( ScriptFairies);

    Object Coins;
    Coins.ORender->SetRender( ACoins);

    Point ScriptCoins;
    Coins.AffectScript(ScriptCoins);


//**************Assignation des objects************

    Engine Game;

    Game.AddObject( &Fairies);
    Game.AddObject( &Coins);

    Game.Game();

    return 1;
}



extern "C"
{
int AddIn_main(int isAppli, unsigned short OptionNum)
{
    main();
    return 1;
}


#pragma section _BR_Size
unsigned long BR_Size;
#pragma section


#pragma section _TOP

int InitializeSystem(int isAppli, unsigned short OptionNum)
{
    return INIT_ADDIN_APPLICATION(isAppli, OptionNum);
}

#pragma section
}

